# SmartPyLogger

```text
....................................................................................
....................................................................................
..........................................-++=..:...................................
.............-.........................=**#######+:.........-.......................
.............................-.......:=#***##**##*=.....................-...........
......-.............................:+******#**##*#=................................
.............-...................:=*********####%##*:...............................
..............................:+************#*####=..................-..............
...-*+=:.................-=****##*****####*######%+:................................
...-*#*#**##*********##**#*******#######**#%%#***#%+................................
...:=*****#*##*######****#*****#####*#*++--*%##***##=.........-.....................
....-******###*##**###**###*#*###****+-...:-*%%#**##%-..................-...........
....:=******###*###****#**#**#####**+:......-*%##***%#-.............................
.....:+*#***##***###******##**###**+:.......:-*%##**#%*-............................
......-*#****######***#**#*##*##**+:.........:-*%#*+*#%#:...........................
......:-*******#**********#***##**-...........-:=*##***#%*:.........................
........:-+#***************##**##**-............:=*##****#%*-.......................
............:=*#************+*###*#+.............-=*###**#%@%#-.....................
.............:-+#*************+*###*-......-......:-+*#%####%%*:....................
.......-.......:-=*#***************+.................-=*#%%%*###%=..................
..................:--##*************-.................:-+*%#****#%*.................
............-.......:--+#************#..................-=*#%#**#%%%-...............
........................::*********--+:...................:-=*###***#%*.............
.../PPPP/PPPPPPPPP..........++#*****--#....................:-=+###*#%%%.............
..| PPPPPPPPPPPPPPP..............-'++-#......................:=#%#***%%+............
..| PPPP_______/PPPP..-.........................-.............:=#%#***%%+...........
..| PPPP......| PPPP..........................................:=#%#***%%+...........
..| PPPPPPPPPPPPPPP./YYYY..../YYYY........-...................:=#%#***%%+...........
..| PPPP/PPPPPPPP..| YYYY...| YYYY............................:=*%##**#%#-..........
..| PPPP_______/...| YYYY...| YYYY.............................=*%%##*#%%=..........
..| PPPP............\ YYYYYYYYYYYY.....ooo....................=+%%%#**%%+...........
..| PPPP.............\ YYYYY_/YYYY.../OOOOO....-.............:=+###**#%#:...........
../____/..............\___/.| YYYY...| OOO...................=+#%#**#%#:............
...................../YYYY..| YYYY....\__/.................:=+***++++**-............
.............-......| YYYYY/ YYYYY...-..............................................
.....................\ YYYYYYYYYY...................................................
.......-..............\________/....................................................
....................................................................................
....................................................................................
```

Thank you so much for downloading and using SmartPyLogger!
Developed by Niklavs Visockis, Ludvig Bergström and Jonas Lorenz -
in June of 2025 at the Couchbase x AWS x Cillers Hackathon.
Special thanks goes out to the Couchbase team and AWS for sponsoring this project.

### FastAPI middleware for comprehensive request/response logging.

## Installation

```bash
pip install smartpylogger .
```

## Usage

```python
from fastapi import FastAPI
from smartpylogger import LoggingMiddleware

app = FastAPI()

# Add your middleware
app.add_middleware(
    LoggingMiddleware,
    api_key="YOUR_API_KEY",
    allowed_origins=["IP", ...]
    )
```

## What it logs:

- **Request details**: Nothing yet
